#include "StdAfx.h"
#include "EventHandler.h"

CEcmDat* m_pEcm;		// Ƃ肠BB

CEventHandler::CEventHandler(void)
{
	m_pTsPacketParser = NULL;
	m_pTsDescrambler = NULL;
	m_pTsServiceSelect = NULL;
	m_pFileWriter = NULL;
	m_pNetworkSend = NULL;
	m_pEcm = NULL;
	m_pKeepRate = NULL;
	m_pProgManager = NULL;
	m_pTsDemuxer = NULL;
	m_pVideoFile = NULL;
	m_pAudioFile = NULL;
	m_pFFmpgVideoBand = NULL;
	m_pFFmpgVideo = NULL;
	m_pFFmpgAudioBand = NULL;
	m_pFFmpgAudio = NULL;

}

CEventHandler::~CEventHandler(void)
{
	Exit();
}

extern bool OpenFFmpeg(LPSTR vlc);


BOOL CEventHandler::Init(DWORD opt,LPCTSTR tsfname,DWORD PacketSize,DWORD buf_margin,DWORD buf_size,DWORD service)
{

	CMediaDecoder* connect;

	m_tsfname = (char*)tsfname;


	m_pEcm = new CEcmDat();
	m_pEcm->SetDiag(OPT_BDIAG & opt ? TRUE : FALSE);


	m_pKeepRate = new CKeepRate(PacketSize,							// pPbg
							buf_margin,								// oCg߂ĂfR[hJn邩
							buf_size, 								// obt@MAXTCY
							( (opt&(OPT_UDP|OPT_FFMPEG)) ? 30*1024*1024 : 0)		// őuԕA30Mbpsɗ}
							);		

	m_pTsPacketParser = new CTsPacketParser(this);
	m_pKeepRate->SetOutputDecoder(m_pTsPacketParser);			// m_pKeepRate->m_pTsPacketParser
	connect = m_pTsPacketParser;

	if(opt&OPT_SEL) {
		m_pTsServiceSelect = new CTsServiceSelect();
		m_pTsServiceSelect->SetServiceId(service);
		
		connect->SetOutputDecoder(m_pTsServiceSelect);			// ->m_pTsServiceSelect
		connect = m_pTsServiceSelect;
	}

	if(opt&OPT_B25) {
		m_pTsDescrambler = new CTsDescrambler(this);
		if(m_pTsDescrambler->OpenBcasCard()){
			connect->SetOutputDecoder(m_pTsDescrambler);		// ->m_pTsDescrambler
			connect = m_pTsDescrambler;
		}
	}

	if(opt&OPT_UDP) {			// UDPo͑I
		m_pNetworkSend = new CNetworkSend(32767);
		m_pNetworkSend->Open("localhost",1234);
		connect->SetOutputDecoder(m_pNetworkSend);				// ->m_pNetworkSend
		connect = m_pNetworkSend;

	} else if (opt&(OPT_DEMUX|OPT_FFMPEG)) {	// demux | ffmpego͑I(TEST)

		m_pProgManager = new CProgManager(this);
		connect->SetOutputDecoder(m_pProgManager);				// ->m_pProgManager

		m_pTsDemuxer = new CTsDemuxer(this);
		m_pTsDemuxer->EnableLipSync(TRUE);
		m_pProgManager->SetOutputDecoder(m_pTsDemuxer);			// ->m_pTsDemuxer

		if (opt&OPT_DEMUX){						// demuxo
			char file_name[_MAX_PATH];
			
			sprintf_s(file_name,"%s.m2v",tsfname);
			m_pVideoFile = new CFileWriter(this);
			if(m_pVideoFile->OpenFile(file_name)){
				m_pTsDemuxer->SetOutputDecoder(m_pVideoFile,	// 		->m_pVideoFile
								CTsDemuxer::OUTPUT_VIDEO);
			} else {
				log_out("t@C:%sJ܂B",file_name);
			}
			sprintf_s(file_name,"%s.aac",tsfname);
			m_pAudioFile = new CFileWriter(this);
			if(m_pAudioFile->OpenFile(file_name)){
				m_pTsDemuxer->SetOutputDecoder(m_pAudioFile,	// 		->m_pAudioFile
								CTsDemuxer::OUTPUT_AUDIO);
			} else {
				log_out("t@C:%sJ܂B",file_name);
			}
		} else {								// FFmpego


			m_pFFmpgVideo = new CHttpSend(this);
			m_pFFmpgVideoBand = new CKeepRate(512,			//packet
												0,				//margin
												100*1024*1024,	//max
												18*1024*1024,	//max_bps
												TRUE,			//copydata
												"M2V",			//name
												this);	//VIDEOpNbVobt@
			m_pTsDemuxer->SetOutputDecoder(m_pFFmpgVideoBand,		//		->m_pFFmpgVideo
							CTsDemuxer::OUTPUT_VIDEO);
			m_pFFmpgVideoBand->SetOutputDecoder(m_pFFmpgVideo);
			m_pFFmpgVideoBand->m_debugmsg = FALSE;
/*
			m_pFFmpgVideo = new CHttpSend(this);
			m_pTsDemuxer->SetOutputDecoder(m_pFFmpgVideo,		//		->m_pFFmpgVideo
							CTsDemuxer::OUTPUT_VIDEO);
*/
			m_pFFmpgAudioBand = new CKeepRate(512,	//packet
												0,				//margin
												5*1024*1024,		//max
												256*1024,		//max_bps
												TRUE,			//copydata
												"AAC",			//name
												this);	//AudiopNbVobt@
			m_pFFmpgAudioBand->m_debugmsg = FALSE;
			m_pFFmpgAudio = new CHttpSend(this);
			m_pTsDemuxer->SetOutputDecoder(m_pFFmpgAudioBand,	// 		->m_pFFmpgAudio
							CTsDemuxer::OUTPUT_AUDIO);
			m_pFFmpgAudioBand->SetOutputDecoder(m_pFFmpgAudio);

#if 0
/*
			FILE* f;
			size_t len;
			BYTE inbuf33[512*1024];
			Sleep(300);

			OpenFFmpeg("C:\\Program Files\\KvO\\cap_sts\\ffmpeg.exe -i http://localhost:1234/ -acodec libmp3lame  -ar 48000 -ab 192k -y out.mpg");


			f = fopen("C:\\Program Files\\KvO\\cap_sts\\test.m2v","rb");
*/
			FILE* f;
			size_t len;
			BYTE inbuf33[1*1024];

			OpenFFmpeg("C:\\Program Files\\KvO\\cap_sts\\ffmpeg.exe -i http://localhost:1234/test.m2v -acodec libmp3lame  -ar 48000 -ab 192k -y out.mpg");


			f = fopen("C:\\Program Files\\KvO\\cap_sts\\test.m2v","rb");
			while(len=fread(inbuf33,sizeof(BYTE),sizeof(inbuf33),f)){

				CMediaData *m = new CMediaData(inbuf33, (DWORD)len);
				m_pFFmpgAudio->InputMedia(m);
				delete m;
//				m = new CMediaData(inbuf33, (DWORD)len);
//				m_pFFmpgAudioBand->InputMedia(m);
			}
			fclose(f);
			delete m_pFFmpgAudioBand;
#endif
		}
	} else {				//t@Co͑I
		m_pFileWriter = new CFileWriter(this);
		if(m_pFileWriter->OpenFile(tsfname)){
			connect->SetOutputDecoder(m_pFileWriter);			// ->m_pFileWriter
			connect = m_pFileWriter;
		} else {
			log_out("t@C:%sJ܂B",tsfname);
		}
	}
	return TRUE;
}

void CEventHandler::Exit(void)
{
	if(m_pEcm)	m_pEcm->exit();

	if(m_pKeepRate)				delete m_pKeepRate;


	if(m_pTsPacketParser)		delete m_pTsPacketParser;
	if(m_pTsServiceSelect)		delete m_pTsServiceSelect;
	if(m_pTsDescrambler)		delete m_pTsDescrambler;
	if(m_pNetworkSend)			delete m_pNetworkSend;
	if(m_pFileWriter)			delete m_pFileWriter;
	if(m_pEcm)					delete m_pEcm;
	if(m_pProgManager)			delete m_pProgManager;
	if(m_pTsDemuxer)			delete m_pTsDemuxer;
	if(m_pVideoFile)			delete m_pVideoFile;
	if(m_pAudioFile)			delete m_pAudioFile;
	if(m_pFFmpgAudio)			delete m_pFFmpgAudio;
	if(m_pFFmpgVideo)			delete m_pFFmpgVideo;
	if(m_pFFmpgVideoBand)		delete m_pFFmpgVideoBand;
	if(m_pFFmpgAudioBand)		delete m_pFFmpgAudioBand;

	m_pTsPacketParser = NULL;
	m_pTsDescrambler = NULL;
	m_pTsServiceSelect = NULL;
	m_pFileWriter = NULL;
	m_pNetworkSend = NULL;
	m_pEcm = NULL;
	m_pKeepRate = NULL;
	m_pProgManager = NULL;
	m_pTsDemuxer = NULL;
	m_pVideoFile = NULL;
	m_pAudioFile = NULL;
	m_pFFmpgVideoBand = NULL;
	m_pFFmpgVideo = NULL;
	m_pFFmpgAudioBand = NULL;
	m_pFFmpgAudio = NULL;
}

void CEventHandler::OnTsData(BYTE* data,DWORD len)
{
	m_pKeepRate->InputMedia(new CMediaData(data, len));
}

void CEventHandler::OnBcasData(BYTE* data,DWORD len)
{
	m_pEcm->set(data,len);
}

void CEventHandler::Reset(void)
{
}

const DWORD CEventHandler::OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam)
{
	// fR[_̃Cxg󂯎(b)
	if(pDecoder == m_pProgManager){
		
		// vO}l[W̃Cxg
		switch(dwEventID){
			case CProgManager::EID_SERVICE_LIST_UPDATED : {
				// T[rX̍\ω
				WORD wVideoPID = 0xFFFF;
				WORD wAudioPID = 0xFFFF;
				m_pProgManager->GetServiceEsPID(&wVideoPID, &wAudioPID);
				m_pTsDemuxer->SetVideoPID(wVideoPID);
				m_pTsDemuxer->SetAudioPID(wAudioPID);
				return 0UL;
				}
			
			case CProgManager::EID_SERVICE_INFO_UPDATED : {
				// T[rX񂪍XVꂽ
				TCHAR szServiceName[1024] = {TEXT("s")};
				m_pProgManager->GetServiceName(szServiceName);
				return 0UL;
				}
			}
		}
	return 0UL;
}
